#include <stdio.h>
#include <stdlib.h>

int n;
long pattern;

/* This function outputs a bit pattern (msb first, starting at position n) */
void output ()
{
	int pos;

	for (pos = n-1; pos >= 0; pos--)
		putchar((pattern & (1 << pos))? '1' : '0');
	putchar('\n');
}

/* inverts the bit at position p (where p=0..n-1) and outputs the pattern */
void changebit (int p)
{
	pattern ^= (1 << p);
	output();
}

/* your program should go here */

void gray_rec (int k)
{
	if (k > 0) gray_rec(k-1);
	changebit(k);
	if (k > 0) gray_rec(k-1);
}

void gray ()
{
	// to be completed
	gray_rec(n-1);
	changebit(n-1);
}

/* takes one argument from command line = number of bits */
int main (int argc, char **argv)
{
	if (argc < 2) { printf("no argument\n"); return -1; }
	n = atoi(argv[1]);
	if (n <= 0 || n > sizeof(pattern)*8)
		{ printf("invalid argument\n"); return -1; }

	pattern = 0;		/* initial pattern */

	output();		/* print initial pattern */
	gray();			/* output the sequence */

	return 0;
}
